<?php
/**
 * Aheadworks Inc.
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the EULA
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * https://ecommerce.aheadworks.com/end-user-license-agreement/
 *
 * @package    Followupemail2
 * @version    2.2.3
 * @copyright  Copyright (c) 2020 Aheadworks Inc. (http://www.aheadworks.com)
 * @license    https://ecommerce.aheadworks.com/end-user-license-agreement/
 */
namespace Aheadworks\Followupemail2\Model\Template\Resolver\Order;

use Magento\Sales\Model\Order\Item as OrderItem;

/**
 * Class OrderItem
 *
 * @package Aheadworks\Followupemail2\Model\Template\Resolver\Order
 */
class Item
{
    /**
     * Retrieve product id for frontend URL generation
     *
     * @param OrderItem $orderItem
     * @return int|null
     */
    public function getProductIdForUrl($orderItem)
    {
        $productId = $orderItem->getProductId();

        $superProductConfig = $orderItem->getProductOptionByCode('super_product_config');
        if (is_array($superProductConfig) && isset($superProductConfig['product_id'])) {
            $productId = $superProductConfig['product_id'];
        }

        if ($orderItem->getParentItem()) {
            $productId = $orderItem->getParentItem()->getProductId();
        }

        return $productId;
    }
}
